---
# This role contains base rules of the firewall
- name: Install ufw package
  become: yes
  apt:
    name:
      - ufw

- name: Configure ufw defaults
  become: yes
  ufw:
    direction: "{{ item.direction }}"
    policy: "{{ item.policy }}"
  with_items:
    - { direction: 'incoming', policy: 'deny' }
    - { direction: 'outgoing', policy: 'allow' }

- name: Define ufw logging policy
  become: yes
  ufw:
    logging: "{{ ufw_logging }}"

- name: Insert customs IPv4 rules in before.rules
  become: yes
  blockinfile:
    dest: "/etc/ufw/before.rules"
    block: "{{ lookup('file', 'files/before-ipv4.rules') }}"
    insertbefore: "^# don't delete the 'COMMIT'"
    marker: "### {mark} ANSIBLE MANAGED BLOCK - IPv4 before rules ###"
  notify:
    - restart ufw

- name: Insert customs IPv6 rules in before6.rules
  become: yes
  blockinfile:
    dest: "/etc/ufw/before6.rules"
    block: "{{ lookup('file', 'files/before-ipv6.rules') }}"
    insertbefore: "^# don't delete the 'COMMIT'"
    marker: "### {mark} ANSIBLE MANAGED BLOCK - IPv6 before rules ###"
  notify:
    - restart ufw

- name: OpenSSH default policy limit
  become: yes
  ufw:
    rule: limit
    port: ssh
    proto: tcp

- name: Add custom ufw firewall rules
  become: yes
  ufw:
    comment: "{{ item.comment }}"
    proto: "{{ item.proto }}"
    src: "{{ item.src }}"
    dest: "{{ item.dest }}"
    port: "{{ item.port }}"
    rule: "{{ item.rule }}"
    direction: "{{ item.direction }}"
  with_items: "{{ ufw_additional_rules|default([]) }}"

# IP forwarding is disabled by default
- name: Set value IPv4 forwarding
  become: yes
  sysctl:
    name: net.ipv4.ip_forward
    value: "{{ ipv4_ip_forwarding }}"
    sysctl_set: yes
    state: present
    reload: yes

- name: Set value IPv6 forwarding
  become: yes
  sysctl:
    name: net.ipv6.conf.all.forwarding
    value: "{{ ipv6_ip_forwarding }}"
    sysctl_set: yes
    state: present
    reload: yes

- name: Enable ufw
  become: yes
  ufw:
    state: enabled
...